import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "igniteui-react-core";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { Dictionary$2 } from "igniteui-react-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { TransitionOutSpeedType } from "./TransitionOutSpeedType";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
/**
 * @hidden
 */
export declare class FinancialEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    get position(): number;
    set position(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _dataSource;
    get dataSource(): FinancialCalculationDataSource;
    set dataSource(a: FinancialCalculationDataSource);
    private _supportingCalculations;
    get supportingCalculations(): FinancialCalculationSupportingCalculations;
    set supportingCalculations(a: FinancialCalculationSupportingCalculations);
    private _basedOn;
    get basedOn(): IList$1<string>;
    set basedOn(a: IList$1<string>);
}
/**
 * @hidden
 */
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    static $t: Type;
    protected g1(): List$1<SeriesLayerPropertyOverlay>;
    private xe;
    private xc;
    private xd;
    private xb;
    private xf;
    jx(): any;
    o2(a: SeriesView): void;
    us: FinancialSeriesView;
    protected get_el(): boolean;
    ag(): Axis[];
    jv(a: any, b: string): any;
    protected wb(): number;
    private v9;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    constructor();
    x1: Brush;
    s5(): Brush;
    s6(): Brush;
    nh(): void;
    protected get_d0(): boolean;
    protected get_fj(): boolean;
    ub: CategoryAxisBase;
    uu: NumericYAxis;
    w1: string;
    get u7(): IFastItemColumn$1<number>;
    set u7(a: IFastItemColumn$1<number>);
    private u2;
    ws: string;
    get u5(): IFastItemColumn$1<number>;
    set u5(a: IFastItemColumn$1<number>);
    private u0;
    wx: string;
    get u6(): IFastItemColumn$1<number>;
    set u6(a: IFastItemColumn$1<number>);
    private u1;
    wf: string;
    get u4(): IFastItemColumn$1<number>;
    set u4(a: IFastItemColumn$1<number>);
    private uz;
    w5: string;
    get u9(): IFastItemColumn$1<number>;
    set u9(a: IFastItemColumn$1<number>);
    private u3;
    wo: string;
    wk: string;
    wm: string;
    wi: string;
    wq: string;
    protected fo(): boolean;
    vh: boolean;
    protected vc: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    vj(): boolean;
    protected xi(a: AssigningCategoryStyleEventArgs): void;
    protected uk: CategorySeriesRenderManager;
    protected xg(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    v1(a: Point): number;
    jg(a: Point, b: boolean): number;
    je(a: Point, b: boolean): number;
    hu(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    tj(a: Point, b: boolean, c: boolean): Point;
    ia(a: Point, b: boolean, c: boolean): number;
    h6(a: Point, b: boolean, c: boolean): number;
    h8(a: Point, b: boolean, c: boolean): number;
    v3(a: Point, b: boolean, c: boolean): number;
    v4(a: Point, b: boolean, c: boolean): number;
    v5(a: Point, b: boolean, c: boolean): number;
    tf(a: Point, b: boolean, c: boolean): Point;
    th(a: Point, b: boolean, c: boolean): Point;
    x3(a: Point, b: boolean, c: boolean): Point;
    x2(a: Point, b: boolean, c: boolean): Point;
    x4(a: Point, b: boolean, c: boolean): Point;
    oc(): void;
    protected qp(a: Rect, b: Rect): void;
    protected qo(a: Rect, b: Rect): void;
    protected vm: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected vn: Dictionary$2<string, string>;
    private u8;
    private xa;
    private vb;
    protected pa(a: any, b: string, c: any, d: any): void;
    ve(a: any): boolean;
    vd(a: any): boolean;
    protected t4(a: number, b: number, c: Axis): any[];
    protected v8(a: SeriesView): number;
    protected wa(a: SeriesView): number;
    t3(a: number, b: number): any[];
    private uy;
    protected get_et(): boolean;
    ni(): void;
    c0(a: any, b: Point, c: boolean): HighlightingInfo;
    wc(a: Point): number;
    protected ux(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected uw(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected vf(): boolean;
    hw(a: Point): number;
    i9(a: Point): number;
    protected get_e6(): boolean;
    as(): CategoryAxisBase;
    jb(a: Point): number;
    js(a: Point): any;
    uf: CategoryFrame;
    uh: CategoryFrame;
    ud: CategoryFrame;
    ue(): CategoryFrame;
    protected v2(a: Rect, b: Rect, c: Rect): number;
    um: CategoryTransitionInMode;
    vi: boolean;
    protected fx(): boolean;
    protected ul(): CategoryTransitionInMode;
    protected cp(): TransitionInSpeedType;
    protected cr(): TransitionOutSpeedType;
    xj(a: CategoryFrame, b: FinancialSeriesView): void;
    xh(a: CategoryFrame, b: FinancialSeriesView): void;
    gm(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    un: CategoryTransitionSourceFramePreparer;
    v6(a: FinancialSeriesView): number;
    protected nl(): void;
    ps(a: boolean): void;
    protected fy(): boolean;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected vk(a: IList$1<string>): boolean;
    get vl(): boolean;
    protected vg(): boolean;
    protected w9(a: FinancialEventArgs): void;
    protected get vt(): IEnumerable$1<number>;
    private _vq;
    private vq;
    protected get vs(): IEnumerable$1<number>;
    private _vp;
    private vp;
    protected get vr(): IEnumerable$1<number>;
    private _vo;
    private vo;
    vv(a: IList$1<number>): IList$1<number>;
    private va;
    protected vu(): IList$1<string>;
    private vz;
    getOpenColumnAsArray(): number[];
    private vx;
    getHighColumnAsArray(): number[];
    private vy;
    getLowColumnAsArray(): number[];
    private vw;
    getCloseColumnAsArray(): number[];
    private v0;
    getVolumeColumnAsArray(): number[];
    protected np(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected uo(a: number, b: number): FinancialCalculationDataSource;
    v7(a: number): number;
    protected up(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    get categoryAxis(): CategoryAxisBase;
    private ug;
    pt(a: Rect, b: RenderSurface): void;
    private uc;
    pq(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    ao(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private ui;
    get uj(): CategoryMode;
    set uj(a: CategoryMode);
    protected get_e0(): boolean;
    p1(a: Brush, b: Brush): void;
    private xk;
    private ut;
    private uv;
    ju(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialCalculationSupportingCalculations extends Base {
    static $t: Type;
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
}
/**
 * @hidden
 */
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    static $t: Type;
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class FinancialCalculationDataSource extends Base {
    static $t: Type;
    private _openColumn;
    get openColumn(): IList$1<number>;
    set openColumn(a: IList$1<number>);
    private _closeColumn;
    get closeColumn(): IList$1<number>;
    set closeColumn(a: IList$1<number>);
    private _highColumn;
    get highColumn(): IList$1<number>;
    set highColumn(a: IList$1<number>);
    private _lowColumn;
    get lowColumn(): IList$1<number>;
    set lowColumn(a: IList$1<number>);
    private _volumeColumn;
    get volumeColumn(): IList$1<number>;
    set volumeColumn(a: IList$1<number>);
    private _indicatorColumn;
    get indicatorColumn(): IList$1<number>;
    set indicatorColumn(a: IList$1<number>);
    private _typicalColumn;
    get typicalColumn(): CalculatedColumn;
    set typicalColumn(a: CalculatedColumn);
    private _trueRange;
    get trueRange(): CalculatedColumn;
    set trueRange(a: CalculatedColumn);
    private _trueLow;
    get trueLow(): CalculatedColumn;
    set trueLow(a: CalculatedColumn);
    private _period;
    get period(): number;
    set period(a: number);
    private _shortPeriod;
    get shortPeriod(): number;
    set shortPeriod(a: number);
    private _longPeriod;
    get longPeriod(): number;
    set longPeriod(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _calculateFrom;
    get calculateFrom(): number;
    set calculateFrom(a: number);
    private _calculateCount;
    get calculateCount(): number;
    set calculateCount(a: number);
    private _multiplier;
    get multiplier(): number;
    set multiplier(a: number);
    private _minimumValue;
    get minimumValue(): number;
    set minimumValue(a: number);
    private _maximumValue;
    get maximumValue(): number;
    set maximumValue(a: number);
    private _specifiesRange;
    get specifiesRange(): boolean;
    set specifiesRange(a: boolean);
    private _series;
    get series(): FinancialSeries;
    set series(a: FinancialSeries);
}
/**
 * @hidden
 */
export declare abstract class FinancialSeriesView extends SeriesView {
    static $t: Type;
    b2: FinancialSeries;
    b0: FinancialBucketCalculator;
    b4: number;
    b3(a: CategoryFrame): boolean;
    b5(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract b1(): FinancialBucketCalculator;
    au(): void;
    getDefaultTooltipTemplate(): string;
    protected af(): void;
}
